#ifndef CONFIG_H
#define CONFIG_H
/* Name of package */
#cmakedefine PACKAGE "@PACKAGE@"

#cmakedefine VERSION "@VERSION@"

/* Define to 1 if you have the <des.h> header file. */
#cmakedefine HAVE_DES_H

/* Define to 1 if you have the <dirent.h> header file, and it defines `DIR'.
   */
#cmakedefine HAVE_DIRENT_H

/* Define to 1 if you have the <dlfcn.h> header file. */
#cmakedefine HAVE_DLFCN_H

/* Define to 1 if you have the <fcntl.h> header file. */
#cmakedefine HAVE_FCNTL_H

/* Define if you have the gssapi.h header file */
#cmakedefine HAVE_GSSAPI_H

/* Define to 1 if you have the <inttypes.h> header file. */
#cmakedefine HAVE_INTTYPES_H

/* Define to 1 if you have the <lber.h> header file. */
#cmakedefine HAVE_LBER_H

/* Define to 1 if you have the <ldap.h> header file. */
#cmakedefine HAVE_LDAP_H

/* Define to 1 if you have the <limits.h> header file. */
#cmakedefine HAVE_LIMITS_H

/* Define to 1 if you have the <malloc.h> header file. */
#cmakedefine HAVE_MALLOC_H

/* Define to 1 if you have the <memory.h> header file. */
#cmakedefine HAVE_MEMORY_H

/* Define to 1 if you have the <ndir.h> header file, and it defines `DIR'. */
#cmakedefine HAVE_NDIR_H

/* Define to 1 if you have the <pam/pam_appl.h> header file. */
#cmakedefine HAVE_PAM_PAM_APPL_H

/* Define to 1 if you have the <paths.h> header file. */
#cmakedefine HAVE_PATHS_H

/* Define to 1 if you have the <security/pam_appl.h> header file. */
#cmakedefine HAVE_SECURITY_PAM_APPL_H

/* Define to 1 if you have the <stdarg.h> header file. */
#cmakedefine HAVE_STDARG_H

/* Define to 1 if you have the <stdint.h> header file. */
#cmakedefine HAVE_STDINT_H

/* Define to 1 if you have the <stdlib.h> header file. */
#cmakedefine HAVE_STDLIB_H

/* Define to 1 if you have the <strings.h> header file. */
#cmakedefine HAVE_STRINGS_H

/* Define to 1 if you have the <string.h> header file. */
#cmakedefine HAVE_STRING_H

/* Define to 1 if you have the <sysexits.h> header file. */
#cmakedefine HAVE_SYSEXITS_H

/* Define to 1 if you have the <syslog.h> header file. */
#cmakedefine HAVE_SYSLOG_H

/* Define to 1 if you have the <sys/dir.h> header file, and it defines `DIR'.
   */
#cmakedefine HAVE_SYS_DIR_H

/* Define to 1 if you have the <sys/file.h> header file. */
#cmakedefine HAVE_SYS_FILE_H

/* Define to 1 if you have the <sys/ndir.h> header file, and it defines `DIR'.
   */
#cmakedefine HAVE_SYS_NDIR_H

/* Define to 1 if you have the <sys/param.h> header file. */
#cmakedefine HAVE_SYS_PARAM_H

/* Define to 1 if you have the <sys/stat.h> header file. */
#cmakedefine HAVE_SYS_STAT_H

/* Define to 1 if you have the <sys/time.h> header file. */
#cmakedefine HAVE_SYS_TIME_H

/* Define to 1 if you have the <sys/types.h> header file. */
#cmakedefine HAVE_SYS_TYPES_H

/* Define to 1 if you have the <sys/uio.h> header file. */
#cmakedefine HAVE_SYS_UIO_H

/* Define to 1 if you have <sys/wait.h> that is POSIX.1 compatible. */
#cmakedefine HAVE_SYS_WAIT_H

/* Define to 1 if you have the <unistd.h> header file. */
#cmakedefine HAVE_UNISTD_H

/* Define to 1 if you have the <varargs.h> header file. */
#cmakedefine HAVE_VARARGS_H

/* Do we have a getnameinfo() function? */
#cmakedefine HAVE_GETNAMEINFO 1

/* Do we have a getaddrinfo() function? */
#cmakedefine HAVE_GETADDRINFO 1

/* Do we have a getpid() function? */
#cmakedefine HAVE_GETPID 1

/* Do we have a gettimeofday() function? */
#cmakedefine HAVE_GETTIMEOFDAY 1

/* Do we have a gettimeofday() function? */
#cmakedefine HAVE_SNPRINTF 1

/* Do we have a socklen_t? */
#undef HAVE_SOCKLEN_T
#ifndef HAVE_SOCKLEN_T
typedef unsigned int socklen_t;
#endif /* HAVE_SOCKLEN_T */

/* define if your compiler has __attribute__ */
#cmakedefine HAVE___ATTRIBUTE__ 1
#ifndef HAVE___ATTRIBUTE__
/* Can't use attributes... */
#define __attribute__(foo)
#endif

#cmakedefine HAVE_SYS_SOCKET_H 1
#ifdef HAVE_SYS_SOCKET_H
  #include <sys/socket.h>
#endif

#cmakedefine HAVE_SYSLOG 1

#cmakedefine HAVE_TIME_H 1

#cmakedefine HAVE_GETOPT_H 1

#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

/* Defined in RFC 1035. max strlen is only 253 due to length bytes. */
#ifndef MAXHOSTNAMELEN
# define MAXHOSTNAMELEN  255
#endif

/* Runtime plugin location */
#cmakedefine PLUGINDIR "@PLUGINDIR@"
#cmakedefine CONFIGDIR "@CONFIGDIR@"

#ifndef HAVE_GETADDRINFO
#define	getaddrinfo	    sasl_getaddrinfo
#define	freeaddrinfo	sasl_freeaddrinfo
#define	gai_strerror	sasl_gai_strerror
#endif

#ifndef HAVE_GETNAMEINFO
#define	getnameinfo	    sasl_getnameinfo
#endif

#if !defined(HAVE_GETNAMEINFO) || !defined(HAVE_GETADDRINFO)
#include "gai.h"
#endif

#ifndef AI_NUMERICHOST   /* support glibc 2.0.x */
#define AI_NUMERICHOST  4
#define NI_NUMERICHOST  2
#define NI_NAMEREQD     4
#define NI_NUMERICSERV  8
#endif

#ifndef WIN32
# include <netdb.h>
# ifdef HAVE_SYS_PARAM_H
#  include <sys/param.h>
# endif
#else /* WIN32 */
# include <winsock2.h>
# ifndef strncasecmp
#  define strncasecmp strnicmp
# endif
# ifndef strcasecmp
#  define strcasecmp stricmp
# endif
# ifndef snprintf
#  define snprintf _snprintf
# endif

/* Registry key that contains the locations of the plugins */
# define SASL_ROOT_KEY "SOFTWARE\\Carnegie Mellon\\Project Cyrus\\SASL Library"
# define SASL_PLUGIN_PATH_ATTR "SearchPath"
# define SASL_CONF_PATH_ATTR "ConfFile"

#endif /* WIN32 */

#ifndef HIER_DELIMITER
# define HIER_DELIMITER @HIER_DELIMITER@
#endif
#endif
